/* deve-se incluir alguns headers porque algumas funes da biblioteca padro de C so utilizadas na traduo. */

#include <alloc.h>
#include <stdlib.h>
#include <stdio.h>

/* define o tipo boolean */
typedef int boolean;
#define true  1
#define false 0

/* define um tipo Func que  um ponteiro para funo */
typedef
  void (*Func)();

/* Para cada classe, deve ser gerada uma estrutura como a abaixo. Se Program tivesse variveis de instncia, estas seriam declaradas nesta estrutura. _class_Program representa em C uma classe em Krakatoa. */

typedef
  struct _St_Program {
       /* ponteiro para um vetor de mtodos da classe */
    Func *vt;
    } _class_Program;

   /* Este  um prottipo de mtodo que cria um objeto da classe Program. Toda classe 
      A no abstrata possui um mtodo new_A que cria e retorna um objeto da classe A.
      O mtodo new_Program  declarado antes do mtodo main, abaixo.
   */
_class_Program *new_Program(void);


   /* 
      Este  o mtodo run da classe Program. Note que o mtodo  traduzido para 
      uma funo de C cujo nome  uma concatenao do nome da classe com o nome
      do mtodo. Sempre h um primeiro parmetro chamado this cujo tipo  a 
      estrutura que representa a classe, neste caso, _class_Program.
   */
void _Program_run( _class_Program *this )
{
      /* os nomes de variveis locais so precedidos por _ */
   int _i;
   int _b;
   boolean _primo;
      /* Strings so mapeadas para char * em C */
   char *_msg;

      /* write com Strings so mapeados para puts em C */
   puts( "Ola, este e o meu primeiro programa" );
   puts( "Digite um numero: ");
      /* read(b), com b inteiro  mapeado para o cdigo entre { e } abaixo */
   { 
     char __s[512];
     gets(__s);
     sscanf(__s, "%d", &_b);
   }
     /* o restante do cdigo  praticamente igual em Krakatoa e C, a menos
        de nomes de identificadores */
   _primo = true;
   _i = 2;

   while ( _i < _b )
      if ( _b%_i == 0 ) {
         _primo = false;
         break;
      }
      else
         _i++;
   if ( _primo != false )
      _msg = "Este numero e primo";
   else
      _msg = "Este numero nao e primo";
   puts(_msg);

}

   /*
      Para toda classe deve ser declarado um vetor de Func (vetor de ponteiro para
      funes). O nome deve ser VTclass_NomeDaClasse, como VTclass_Program. Este
      vetor  inicializado (iniciado) com as funes em C, como _Program_run, que
      representam os mtodos **pblicos** da classe. Note que o tipo de _Program_run
       void (*)(_class_program *) e portanto  necessrio um cast para convert-lo
      para o tipo de Func, void (*)()
   */
Func VTclass_Program[] = {
  ( void (*)() ) _Program_run
  };

   /*
      Para toda classe no abstrata se declara uma funo new_NomeDaClasse que aloca
      memria para um objeto da classe, que  um "objeto" da estrutura
       _class_NomeDaClasse. Note que este mtodo  igual para todas as classes, a 
       menos do nome da classe. 
   */

_class_Program *new_Program()
{
  _class_Program *t;

  if ( (t = malloc(sizeof(_class_Program))) != NULL )
       /* o texto explica porque vt  inicializado */ 
    t->vt = VTclass_Program;
  return t;
}

   /* genC de Program da ASA deve gerar a funo main exatamente como abaixo. */
int main() {
  _class_Program *program;

    /* crie objeto da classe Program e envie a mensagem run para ele */
  program = new_Program();
  ( ( void (*)(_class_Program *) ) program->vt[0] )(program);
  return 0;
}


